//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// Simple Stream Library for HP49g+


#include <stdio.h>
#include <stdlib.h>
#include <fsystem.h>


int fputc(int c, FILE *f)
{
    int ret;
    char b = (char) c;
    if(f==NULL) return c;
    if(!f->writecache) {
    	f->cacheused=0;
    	f->writecache=malloc(512);
    	if(!(f->writecache)) return c;
    }
    
    if(f->cacheused==512) { ret = FSWrite(f->writecache,512,f->file);
    f->cacheused=1;
    f->writecache[0]=b;
    return (ret !=512) ? EOF : c;

    }
    else f->writecache[f->cacheused++]=b;

    return c;

}



