//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <hpgcc3.h>


// ROMLIB CHECKED

// BUFFER MUST HAVE 8 WORDS

void cpu_clksave(unsigned int *buffer)
{
memcpyw(buffer,(int *)CLK_REGS,6);
memcpyw(buffer+6,(int *)(MEM_REGS+4),2);
}


// WARNING: AN INVALID BUFFER HERE IS A SERIOUS CRASH

void cpu_clkrestore(unsigned int *buffer)
{
volatile unsigned int *CLK=(unsigned int *)CLK_REGS;

//	lcd_sync();
	
//volatile unsigned int *LCDPTR=(unsigned int *)LCD_REGS;
// TURN LCD OFF	
//LCDPTR[0]&=0xFFFFFFFE;	
	



// ENSURE PLL IS OFF
CLK[4]|=0x10;

// RESTORE MEMORY VALUES
memcpyw((int *)(MEM_REGS+4),buffer+6,2);


// RESTORE PLL VALUES
memcpyw((int *)CLK_REGS,buffer,4);
// RESTORE CLKDIVN
CLK[5]=buffer[5];
// RESTORE PREVIOUS MODE
CLK[4]=buffer[4];

	// FIX LCD TIMING	
//	__lcd_fix();


}
