//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fschattr.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"





int FSChAttr(FS_FILE *file,int newattr)
{
int error;

if(!FSystem.Init) return FS_ERROR;

if(file==NULL) return FS_ERROR;

if(file->Volume&(~3)) return FS_ERROR;		// INVALID VOLUME --> FILE STRUCTURE CORRUPT


if( (file->Mode&FSMODE_WRITE) && (newattr&FSATTR_RDONLY)) {

// FINISH A WRITING SESSION

error=FSFlushBuffers(file);
if(error!=FS_OK) { return error; }

file->Mode&=~(FSMODE_WRITE|FSMODE_MODIFY|FSMODE_APPEND);	// DISABLE ALL WRITE MODES

}

file->Attr=newattr;

return FS_OK;
}
