//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsrmdir.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"




int FSRmdir(char *name)
{
int error;
FS_FILE *dir;
FS_FILE entry;

error=FSOpenDir(name,&dir);

if(error!=FS_OK) return error;

while(error==FS_OK) {
error=FSGetNextEntry(&entry,dir);
if(error==FS_OK) {
if(strcmp(entry.Name,".") && strcmp(entry.Name,"..")) {
FSReleaseEntry(&entry);
FSClose(dir);
return FS_USED;
}
FSReleaseEntry(&entry);
}
}

if(error!=FS_EOF) { FSClose(dir); return error; }

// DIRECTORY IS EMPTY, OK TO REMOVE

return FSCloseAndDelete(dir);

}

