//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsseek.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"




// ASSUME SEEK_... CONSTANTS ARE DEFINED SOMEWHERE ELSE
// ACCEPTS SETTING OFFSET BEYOND END-OF-FILE

int FSSeek(FS_FILE *file,int Offset,int position)
{
int from;
from=0;
if(position==SEEK_END) from=file->FileSize;
if(position==SEEK_CUR) from=file->CurrentOffset;

from+=Offset;

if(from<0) from=0;
file->CurrentOffset=from;
return FS_OK;

}
