//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stddef.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

unsigned char _hpg_gray4_get(hpg_t *g, int x, int y)
{
    volatile char *fb = g->drawfb + g->fbwidth * y + (x >> 2);
    int index = (x & 3) << 1;
    unsigned color = ((0x3 << index) & *fb) >> index;
    return color | (color << 2) | (color << 4) | (color << 6);
}
