//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdlib.h>
#include "hpgraphics.h"
#include "hpgpriv.h"
#include <master_globals.h>

void hpg_set_mode_mono(int dbuf)
{
    hpg_init();

    char *plane1;
    char *plane2;

    if (dbuf)
    {
        plane1 = (char *) sys_phys_malloc(1720 * 2);
        plane2 = plane1 + 1720;
    }
    else
    {
        plane2 = plane1 = DEFAULT_PLANE;
    }

    // PARAMETERS CHANGED BY CLAUDIO
    _hpg_set_mode(MODE_MONO,plane1, plane2, _hpg_mono_draw, _hpg_mono_get);
}
