//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// ROMLIB CHECKED

// ADDED BY CLAUDIO - JAN 2005
#include <master_globals.h>


void cpu_inton()
{
    //ARM ints on

    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;

    // CHANGED BY CLAUDIO - APR 2005
    if(__mg->__saveint) *INTMSK = __mg->__saveint;
}


// LOW-LEVEL VERSION USED BY THE EXCEPTION HANDLERS
// RESTORES A PREVIOUSLY SAVED INTERRUPT STATE
void __cpu_inton(unsigned int state)
{
    //ARM ints on

    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;

    *INTMSK=state;
}

