//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// $Id: dround.c 393 2007-03-04 23:17:29Z ingo $

// ROMLIB CHECKED
// < ibl ; 2006-04-03 >

#include <hpgcc3.h>

double
dround(double v, int d)
{
		// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006

    double scale = 1.0, expo = i10powx(abs(d));
    int minus,expo2,iexp;
    
    if ((minus = v < 0.0))
        v = -v;
    
    frexp(v,&expo2);
    iexp = (int) (expo2*M_LN2/M_LN10);
    
    if (iexp < 0)
			// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006

        v *= (scale = i10powx(-iexp));
    
    v = (round(v * expo ) / expo) / scale;
    //v = ((double) (((ULONGLONG) (v * expo + .5))/expo))/scale;

    return minus ? -v : v;
}


