//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <sys.h>

int
fprintf(FILE *f, const char *fmt, ...)
{
    va_list argp;
    char *out;
    int ret,ret1;
    
    if (! (out = (char*) malloc(4096)) ) 
        sys_error("fatal:can't malloc in fprintf",-1);
    
    va_start(argp, fmt);
    
    ret = vsprintf(out,fmt,argp);
    ret1 = fputs(out,f);
    free(out);
    
    va_end(argp);
    
    return ret1 == 0 ? ret : EOF;
}
